Index: /trunk/tracy/tools/soltracy.cc
===================================================================
--- /trunk/tracy/tools/soltracy.cc	(revision 31)
+++ /trunk/tracy/tools/soltracy.cc	(revision 32)
@@ -127,11 +127,28 @@
   //print flat file with all the design values of the lattice,
   prtmfile("flat_file.dat");
-  // print location, twiss parameters and close orbit at all elements position to a file
-  getcod(dP, lastpos);
-  prt_cod("cod.out", globval.bpm, true);
-
+  
+  //find the closed orbit of a ring
+  if(globval.RingType == 1){
+    getcod(dP, lastpos);
+    
+    // compute up to 3rd order momentum compact factor
+    get_alphac2(); 
+  }
+  
+  
+  // print location, twiss parameters and close orbit/orbit at the BPM positions to a file
+    if(globval.bpm !=0){
+      prt_beampos("6Dcod.out");
+    }
+  
+    
+    
+    
+  
+  
+    
+  
   //get_matching_params_scl(); // get tunes and beta functions at entrance
-  // compute up to 3rd order momentum compact factor
-  get_alphac2(); 
+ 
   //cout << endl << "computing tune shifts" << endl;
   //dnu_dA(10e-3, 5e-3, 0.002);
Index: /trunk/tracy/tracy/inc/field.h
===================================================================
--- /trunk/tracy/tracy/inc/field.h	(revision 31)
+++ /trunk/tracy/tracy/inc/field.h	(revision 32)
@@ -233,6 +233,6 @@
 
 
-typedef ss_vect<double>  Vector;
-typedef Vector           Matrix[ss_dim];
+typedef ss_vect<double>  Vector;                 /*6*1 vector*/
+typedef Vector           Matrix[ss_dim];         /*6*6 matrix*/
 
 
Index: /trunk/tracy/tracy/inc/tracy_global.h
===================================================================
--- /trunk/tracy/tracy/inc/tracy_global.h	(revision 31)
+++ /trunk/tracy/tracy/inc/tracy_global.h	(revision 32)
@@ -3,5 +3,5 @@
 
 typedef struct globvalrec {
-  double        dPcommon,       // dp for numerical differentiation 
+  double        dPcommon,       // dp for numerical differentiation; defined in lattice
                 dPparticle;     // energy deviation 
   double        delta_RF;       // RF acceptance 
@@ -9,12 +9,12 @@
   double        Omega,
                 U0,             // energy lost per turn in keV 
-                Alphac;         // alphap 
+                Alphac;         // momentum compaction factor
   Vector2       Chrom;          // chromaticities 
-  double        Energy;         // ring energy 
-  long          Cell_nLoc,      // number of elements in a cell
+  double        Energy;         // ring energy; defined in lattice 
+  long          Cell_nLoc,      // number of elements in a cell (For example, a lattice can have several same cells)
                 Elem_nFam,      // number of families 
                 CODimax;        /* maximum number of cod search before
 				   failing */
-  double        CODeps;         // precision for closed orbit finder
+  double        CODeps;         // precision for closed orbit finder; defined in the lattice
   Vector        CODvect;        // closed orbit; beam position at the first element of lattice 
   
@@ -35,11 +35,11 @@
                 Vi;             // imaginal par of the eigenvectors 
 
-  bool          MatMeth,        // matrix method 
+  bool          MatMeth,        // matrix method or symplectic tracking? 
                 Cavity_on,      // if true, cavity turned on 
                 radiation,      // if true, radiation turned on 
-                emittance,
-                quad_fringe,    /* dipole- and quadrupole hard-edge
+                emittance,       // calculate emittance?
+                quad_fringe,    /* dipole- and quadrupole hard-edge?
 				   fringe fields. */
-                H_exact,        // "small ring" Hamiltonian. 
+                H_exact,        // "small ring" or approximation Hamiltonian?  
                 pathlength,     // absolute path length
                 stable,
@@ -105,14 +105,15 @@
   mpolArray   PBrnd;     // random scale factor of rms error PBrms gradient, bn and an
   mpolArray   PB;        // total field strength(design,sys,rms) gradient, bn and an
+  //basic parameters 
   int         Porder;    // The highest order in PB
   int         n_design;  // multipole order (design, All = 0, Dip = 1, Quad = 2, Sext = 3, Oct = 4, Dec = 5, Dodec = 6)
   pthicktype  Pthick;    // thick element
-  // Bending Angles
+  // dipole type
   double PTx1;           // horizontal entrance angle [deg]
   double PTx2;           // horizontal exit angle [deg]
   double PH1;            // bending curvature of the entrance pole face of dipole, see P116 SAC-75. 
   double PH2;            // bending curvature of the exit pole face of dipole, see P116 SAC-75. 
-  double Pgap;           // total magnet gap [m] 
-  double Pirho;          // angle([radian], but in lattice definition, angle is with unit degree)/length of the dipole, 1/rho [1/m] 
+  double Pgap;           // total dipole gap [m] 
+  double Pirho;          // curvature of the dipoles. 1/rho [1/m] 
   double Pc0, Pc1, Ps1;  // corrections for roll error of bend 
   Matrix AU55,           // Upstream 5x5 matrix 
@@ -285,3 +286,5 @@
 				         maxampl[X_][0] < x < maxampl[X_][1]
 					 maxampl[Y_][0] < y < maxampl[Y_][1] */
-};
+
+   Vector        CODvect;        //orbit at the end of the lattice element  Added by Jianfeng Zhang @ LAL, 01/04/2014.
+};
Index: /trunk/tracy/tracy/src/mathlib.cc
===================================================================
--- /trunk/tracy/tracy/src/mathlib.cc	(revision 31)
+++ /trunk/tracy/tracy/src/mathlib.cc	(revision 32)
@@ -218,8 +218,13 @@
 }
 
-
+/***********************************************************
+ * void CopyVec(const int n, const Vector &a, Vector &b)
+ * 
+ *  Copy 6D vector a to b: b = a. 
+ * 
+ ***********************************************************/
 void CopyVec(const int n, const Vector &a, Vector &b)
 {
-  int i;
+  int i=0;
 
   for (i = 0; i < n; i++)
@@ -457,8 +462,15 @@
 
 
+/*********************************************************
+ * void MulLMat(const int n, const Matrix &A, Matrix &B)
+ * 
+ * Matrix multiplication.  B = A * B
+ * 
+ * 
+ **********************************************************/
 void MulLMat(const int n, const Matrix &A, Matrix &B)
 {
-  int i, j, k;
-  double x;
+  int i=0, j=0, k=0;
+  double x=0.0;
   Matrix C;
 
@@ -474,9 +486,15 @@
 }
 
-
+/*********************************************************
+ * void MulRMat(const int n, const Matrix &A, Matrix &B)
+ * 
+ * Matrix multiplication.  A = A * B
+ * 
+ * 
+ **********************************************************/
 void MulRMat(const int n, Matrix &A, const Matrix &B)
 {
-  int i, j, k;
-  double x;
+  int i=0, j=0, k=0;
+  double x=0.0;
   Matrix C;
 
@@ -492,5 +510,13 @@
 }
 
-
+/*********************************************************
+ * double TrMat(const int n, const Matrix &A)
+ * 
+ * Calculate the trance of the matrix A.
+ * 
+ *  return:
+ *          x.
+ * 
+ **********************************************************/
 double TrMat(const int n, const Matrix &A)
 {
Index: /trunk/tracy/tracy/src/nsls-ii_lib.cc
===================================================================
--- /trunk/tracy/tracy/src/nsls-ii_lib.cc	(revision 31)
+++ /trunk/tracy/tracy/src/nsls-ii_lib.cc	(revision 32)
@@ -763,7 +763,7 @@
 		      1.5  sextupole
 		      2.0  bpm 
-      Fnum        family index
+      Fnum        family index of the BPM.
       all         true, print the cod at all elements
-                  false, print the cod at the family elements
+                  false, print the cod at the BPM elements, the name of the BPM must be defined in the "*.prm" file.
    Output:
        none
@@ -784,8 +784,8 @@
 void prt_cod(const char *file_name, const int Fnum, const bool all)
 {
-  long      i;
+  long      i=0L;
   double    code = 0.0;
   FILE      *outf;
-  long      FORLIM;
+  long      FORLIM=0L;
   struct    tm *newtime;
 
@@ -828,6 +828,6 @@
       }
       /* COD is in local coordinates */
-      fprintf(outf, "%4ld %.*s %6.2f %4.1f %6.3f %6.3f %6.3f %6.3f"
-	      " %6.3f %6.3f %6.3f %6.3f %6.3f %6.3f\n",
+      fprintf(outf, "%4ld %.*s %6.2f %4.1f %6.4f %6.4f %6.4f %6.4f"
+	      " %6.4f %6.4f %6.4f %6.4f %6.4f %6.4f\n",
 	      i, SymbolLength, Cell[i].Elem.PName, Cell[i].S, code,
 	      Cell[i].Beta[X_], Cell[i].Nu[X_],
@@ -842,20 +842,35 @@
 }
 
+/****************************************************************
+ * void prt_beampos(const char *file_name)
+ * 
+ *  print the orbits at all lattice elements.
+ * 
+ * Comments:   
+ *     To use this command, the BPM name should be defined in the
+ *  "*.prm" file with the command 
+ *                bpm_name   BPM_names
+ *
+ * 
+ ****************************************************************/
 
 void prt_beampos(const char *file_name)
 {
-  int       k;
+  int       i=0;
   ofstream  outf;
 
   file_wr(outf, file_name);
 
-  outf << "# k  s  name x   px    y   py   delta ct" << endl;
+  outf << "#   i     name              s[m]     x[mm]   px    y[mm]   py   delta ct" << endl;
   outf << "#" << endl;
 
-  for (k = 0; k <= globval.Cell_nLoc; k++)
-    outf << scientific << setprecision(5)
-	 << setw(5) << k << setw(11) << Cell[k].Elem.PName
-	 << setw(13) << Cell[k].BeamPos << endl;
-
+  
+  for (i = 0; i <= globval.Cell_nLoc; i++){
+   if (Cell[i].Fnum == globval.bpm)
+        outf << scientific << setprecision(4)
+	  << setw(5) << i << setw(20) << Cell[i].Elem.PName 
+	  << setw(5) << Cell[i].S 
+	  << setw(13) << Cell[i].BeamPos*1e3 << endl;
+  }	
   outf.close();
 }
@@ -874,12 +889,12 @@
   // the dT and roll angle are all printed out
 {
-  int i,j;
-  int  n_girders;
-  int  gs_Fnum, ge_Fnum;
-  int  gs_nKid, ge_nKid;
-  int  dip_Fnum,dip_nKid;
-  int  loc, loc_gs, loc_ge;
+  int i=0,j=0;
+  int  n_girders=0;
+  int  gs_Fnum=0, ge_Fnum=0;
+  int  gs_nKid=0, ge_nKid=0;
+  int  dip_Fnum=0,dip_nKid=0;
+  int  loc=0, loc_gs=0, loc_ge=0;
   char * name;
-  double s;
+  double s=0.0;
   double PdSsys[2], PdSrms[2], PdSrnd[2], dS[2], dT[2];
   fstream fout;
@@ -5285,11 +5300,11 @@
   Purpose:
            Calculate momentum compact factor up to third order.
-	   Method:
-	   track the orbit offset c*tau at the first element,
-	   at 11 different energy offset(-10-3 to 10-3), then 
-	   use polynomal to fit the momentum compact faction factor
-	   up to 3rd order.
-	   The initial coorinates are (x_co,px_co,y_co,py_co,delta,0).
-	   
+           Method:
+           track the orbit offset c*tau at the first element,
+           at 11 different energy offset(-10-3 to 10-3), then 
+           use polynomal to fit the momentum compact faction factor
+           up to 3rd order.
+          The initial coorinates are (x_co,px_co,y_co,py_co,delta,0).
+          
  Input:
        none
@@ -5307,5 +5322,5 @@
        change the initial coorinates from (0 0 0 0 delta 0) to 
               (x_co,px_co,y_co,py_co,delta,0).	i.e., track
-	      around the off-momentum close orbit but not zero orbit.      
+       around the off-momentum close orbit but not zero orbit.      
 
 *******************************************************************/
@@ -5320,14 +5335,13 @@
  //const double  d_delta  = 1e-4;
 
-  int       i, n;
-  long int  lastpos;  // last tracking position when the particle is stable 
-  double    delta[2*n_points+1], alphac[2*n_points+1], sigma;
+  int       i=0, n=0;
+  long int  lastpos=0L;  // last tracking position when the particle is stable 
+  double    delta[2*n_points+1], alphac[2*n_points+1], sigma=0.0;
   Vector    x, b;
   CellType  Cell;
-  bool      cod;
+  bool      cod=false;
   
   globval.pathlength = false;
   getelem(globval.Cell_nLoc, &Cell); 
-  n = 0;
   
   for (i = -n_points; i <= n_points; i++) {
@@ -5353,4 +5367,10 @@
 
 
+/**********************************************************
+ * float f_bend(float b0L[])
+ * 
+ * 
+ * 
+ **********************************************************/
 float f_bend(float b0L[])
 {
Index: /trunk/tracy/tracy/src/physlib.cc
===================================================================
--- /trunk/tracy/tracy/src/physlib.cc	(revision 31)
+++ /trunk/tracy/tracy/src/physlib.cc	(revision 32)
@@ -263,10 +263,11 @@
 
 /****************************************************************************/
-/* void printglob2file(void)
-
- Purpose:
- Print global variables on screen
- Print tunes and chromaticities
- Print Oneturn matrix
+/* void printglob2file(const char fic[])
+
+ Purpose:
+ Print global variables, 
+       tunes and chromaticities, and
+       Oneturn matrix,
+       to an external file.
 
  Input:
@@ -615,6 +616,6 @@
 void TraceABN(long i0, long i1, const Vector2 &alpha, const Vector2 &beta,
         const Vector2 &eta, const Vector2 &etap, const double dP) {
-    long i, j;
-    double sb;
+    long i=0, j=0;
+    double sb=0.0;
     ss_vect<tps> Ascr;
 
Index: /trunk/tracy/tracy/src/prtmfile.cc
===================================================================
--- /trunk/tracy/tracy/src/prtmfile.cc	(revision 31)
+++ /trunk/tracy/tracy/src/prtmfile.cc	(revision 32)
@@ -86,5 +86,5 @@
  Type codes:
  marker         -1
- drift	    0
+ drift           0
  multipole       1
  cavity          2
@@ -166,5 +166,5 @@
  ******************************************************************************/
 void prtmfile(const char mfile_dat[]) {
-  int i, j;
+  int i=0, j=0;
   FILE *mfile;
 
@@ -192,6 +192,6 @@
         fprintf(mfile, " %23.16e %23.16e %23.16e\n", Cell[i].dS[X_],
             Cell[i].dS[Y_], Cell[i].Elem.M->PdTsys + Cell[i].Elem.M->PdTrms
-                * Cell[i].Elem.M->PdTrnd);
-        prtHOM(mfile, Cell[i].Elem.M->n_design, Cell[i].Elem.M->PB,
+                * Cell[i].Elem.M->PdTrnd);         
+	prtHOM(mfile, Cell[i].Elem.M->n_design, Cell[i].Elem.M->PB,
             Cell[i].Elem.M->Porder);
       }
Index: /trunk/tracy/tracy/src/read_script.cc
===================================================================
--- /trunk/tracy/tracy/src/read_script.cc	(revision 31)
+++ /trunk/tracy/tracy/src/read_script.cc	(revision 32)
@@ -78,12 +78,12 @@
  
   
-  char    str[max_str]="voidstring", dummy[max_str]="voidstring",dummy2[max_str]="voidstring", nextpara[max_str]="voidpara";
-  char    in[max_str];  //temporary line with preceding white space
+  char    str[max_str]="", dummy[max_str]="",dummy2[max_str]="", nextpara[max_str]="";
+  char    in[max_str]="";  //temporary line with preceding white space
   char    *line = NULL; //line to store the command without preceding white space
   size_t   len = 0;
   ssize_t  read;
-  char    name[max_str]="voidname";
+  char    name[max_str]=""; //initialize with empty character array.
  // char    lat_file[max_str]="voidlattice";
-  char    EndName[]="void";
+  char    EndName[5]="";
 
   FILE    *inf;
@@ -92,6 +92,6 @@
   long int    NameLen=0L;
   int idummy=0;
-  char full_param_file_name[max_str];
-  char lat_FileName[max_str];
+  char full_param_file_name[max_str]="";
+  char lat_FileName[max_str]="";
  //bool TuneTracFlag;
   char *pch;
@@ -115,5 +115,5 @@
      
      LineNum++;
-     if(prt){
+     if(!prt){
        printf("Line # %ld \n",LineNum);
        printf("Retrieved line of length %zu : \n",read);
@@ -126,4 +126,6 @@
     if (strstr(line, "#") == NULL && line[0] != '\n' &&
         line[0] != '\r' && strcmp(line, "\r\n") != 0 ){
+    
+        
       // get initial command token
       sscanf(line, "%s", name); 
@@ -134,9 +136,10 @@
       //find the sequence of the bool flag in user input script 
       NameLen = strlen(name);
-      EndName[0] = name[NameLen-4];
-      EndName[1] = name[NameLen-3];
-      EndName[2] = name[NameLen-2];
-      EndName[3] = name[NameLen-1];          
-      
+      if(NameLen >= 4 ){
+	EndName[0] = name[NameLen-4];
+	EndName[1] = name[NameLen-3];
+	EndName[2] = name[NameLen-2];
+	EndName[3] = name[NameLen-1];          
+      }
       //find the bool flag whose last 4 character are 'Flag' 
       if(strcmp(EndName,"Flag")==0)
Index: /trunk/tracy/tracy/src/soleilcommon.cc
===================================================================
--- /trunk/tracy/tracy/src/soleilcommon.cc	(revision 31)
+++ /trunk/tracy/tracy/src/soleilcommon.cc	(revision 32)
@@ -153,6 +153,7 @@
     /*check whether the RF cavity hormonic number is defined or not*/
     if(Cell[Elem_GetPos(globval.cav, 1)].Elem.C->Ph == 0){
-      printf("soleilcommon():    Error!!! Please define RF harmonic number in the lattice! \n"
-              "Because this parameter will be used to calculate stable phase for positive / negative momentum compaction factor\n");
+      printf("soleilcommon():    Error!!! Please define the RF harmonic number in the lattice! \n"
+              "Because this parameter will be used to calculate the stable phase for the lattice with the "
+	      "positive / negative momentum compaction factor\n");
       exit_(1);
     }
@@ -169,9 +170,9 @@
     globval.emittance  = false; /* emittance  on/off */
     globval.pathlength = false; /* Path lengthening computation */
-    globval.CODimax    = 40L;   /* maximum number of iterations for COD algo */
+    globval.CODimax    = 40L;   /* maximum number of iterations for COD algorithm */
     globval.dPcommon   = 1e-10; /* Common energy step for energy differentiation */
     globval.delta_RF  = RFacceptance;/* energy acceptance for SOLEIL */
 
-   /* define x/y physical aperture, use the default values: +- 1 meter  */
+   /* define x/y physical aperture (vacuum chamber), use the default values: +- 1 meter  */
     globval.Aperture_on = false;
     
@@ -183,14 +184,15 @@
   else 
   { // for transfer lines  
-    /* Initial settings : */
-    beta[0]  = 8.1;
-    alpha[0] = 0.0;
-    beta[1]  = 8.1;
-    alpha[1] = 0.0;
-    eta[0]   = 0.0;
-    etap[0]  = 0.0;
-    eta[1]   = 0.0;
-    etap[1]  = 0.0;
-
+    /* Initial optical parameters of the transfer line: */
+    beta[0]  = 34.46;   // beta_x
+    beta[1]  = 33.94;   // beta_y
+    alpha[0] = -4.24;   // alpha_x
+    alpha[1] = -4.34;   // alpha_y
+    eta[0]   = 0.0;   // eta_x
+    etap[0]  = 0.0;   // etap_x
+    eta[1]   = 0.0;   // eta_y
+    etap[1]  = 0.0;   // etap_y
+
+    // set the initial orbit of the transfer line is zero
      for (i = 0; i < ss_dim; i++) {
     {
@@ -200,4 +202,6 @@
     dP = codvect[4];
 
+    codvect[0]=1e-4;
+    
     /* Defines global variables for Tracy code */
     globval.MatMeth = false;  /* matrix method */
@@ -214,6 +218,9 @@
     globval.Aperture_on = false;
     
-    
+    // transfer the optical functions and the orbit
     TransTwiss(alpha, beta, eta, etap, codvect);
+  
+    // print location, twiss parameters and close orbit/orbit at all elements position to a file
+      prt_cod("cod.out", globval.bpm, true);
     }
   }//finish read the transfer line 
Index: /trunk/tracy/tracy/src/t2cell.cc
===================================================================
--- /trunk/tracy/tracy/src/t2cell.cc	(revision 31)
+++ /trunk/tracy/tracy/src/t2cell.cc	(revision 32)
@@ -798,9 +798,9 @@
      fixed point for the lattice with negative momentum compact factor.  
       28/06/11   Correct the one turn map for the lattice with negative momentum compact factor, now the one turn map is
-      tracked around the COD.
+      tracked around the COD. By Jianfeng Zhang @ SOLEIL
 ****************************************************************************/
 bool Cell_getCOD(long imax, double eps, double dP, long &lastpos)
 {
-  long             j = 0, n = 0, n_iter = 0, h_RF = 0;
+  long             j = 0L, n = 0L, n_iter = 0L, h_RF = 0L;
   double           dxabs = 0.0;
   iVector          jj;
@@ -845,5 +845,5 @@
     }
     
-  n_iter = 0; 
+    
   I.identity();
   
Index: /trunk/tracy/tracy/src/t2elem.cc
===================================================================
--- /trunk/tracy/tracy/src/t2elem.cc	(revision 31)
+++ /trunk/tracy/tracy/src/t2elem.cc	(revision 32)
@@ -885,5 +885,5 @@
 
  Comments:
- 06/11/2012     Jianfeng Nadolski @ LAL
+ 06/11/2012     Jianfeng Zhang @ LAL
                 Fix the bug in the kick map of the exact Hamiltonian. 
                 Add the second order of the approximate Hamiltonian.
@@ -893,5 +893,5 @@
 void thin_kick(int Order, double MB[], double L, double h_bend, double h_ref,
         ss_vect<T> &x) {
-    int j;
+    int j=0;
     T BxoBrho, ByoBrho, ByoBrho1, B[3];
     T sqrtpx, dpx, ps2new, psnew;
@@ -2448,10 +2448,10 @@
 
  Input:
- xref vector
- x    matrix
+ xref: 6*1 orbit 
+ x:    6*6 (optics) transfer matrix? 
 
  Output:
- xref
- x
+ xref:  6*1 orbit
+ x:   6*6 (optics) transfer matrix
 
  Return:
@@ -2622,5 +2622,5 @@
      */
 
-    double L;
+    double L=0.0;
     CellType *cellp;
     elemtype *elemp;
@@ -2674,5 +2674,5 @@
      (  0    0     0    0       1  )                     */
 
-    double t, sk, sk0, s, c;
+    double t=0.0, sk=0.0, sk0=0.0, s=0.0, c=0.0;
     Matrix a, ah, av;
 
@@ -2771,7 +2771,7 @@
      cos phi                                              */
 
-    double r, s, c, sk, p, fk, afk;
+    double r=0.0, s=0.0, c=0.0, sk=0.0, p=0.0, fk=0.0, afk=0.0;
     Matrix edge, ah, av;
-    double coef, scoef;
+    double coef=0.0, scoef=0.0;
 
     if (irho == 0.0) {
@@ -4126,5 +4126,5 @@
  ****************************************************************************/
 void Drift_Init(int Fnum1) {
-    int i;
+    int i=1;
     ElemFamType *elemfamp;
     CellType *cellp;
@@ -4171,6 +4171,6 @@
 
 void Mpole_Init(int Fnum1) {
-    double x;
-    int i;
+    double x=0.0;
+    int i=1;
     ElemFamType *elemfamp;
     CellType *cellp;
Index: /trunk/tracy/tracy/src/t2lat.cc
===================================================================
--- /trunk/tracy/tracy/src/t2lat.cc	(revision 31)
+++ /trunk/tracy/tracy/src/t2lat.cc	(revision 32)
@@ -258,5 +258,5 @@
 static long CheckUDItable(const char *name, struct LOC_Lattice_Read *LINK)
 {
-  long  i, j, FORLIM;
+  long  i=0, j=0, FORLIM=0;
 
   j = 0;
@@ -2652,8 +2652,8 @@
     QL = 0.0;   /* L */
     QKick = 0.0; /* kick angle of the corrector [rad]*/
-    Kplane = 0;   /* 1 is horizontal corrector, -1 is vertical corrector */
-    k1 = 1;     /* N */
-    k2 = Meth_Linear;   /* method */
-    dt = 0.0;
+    Kplane = 1;   /* 1 is horizontal corrector, -1 is vertical corrector */
+    k1 = 1;     /* N, cut piece of corrector */
+    k2 = Meth_Linear;   /* integartion method */
+    dt = 0.0;    /* roll angle of the corrector */
     ClearHOMandDBN(&V);
     getest__(P_expset(SET, 1 << ((long)comma)), "<, > expected", &V);
@@ -2668,5 +2668,5 @@
       P_addset(mysys, (long)rollsym);
       P_addset(mysys, (long)dbnsym);
-      do {   /*5: read L, K, N, T, T1, T2 */
+      do {   /*5: read L, kick angle, cut piece, integartion method, roll angle, T2 */
 	test__(mysys, "illegal parameter", &V); sym1 = *V.sym;
 	if (*V.sym == (long)dbnsym || *V.sym == (long)rollsym ||
@@ -2714,4 +2714,8 @@
 	    else if (sym1 == versym)
 	      Kplane = -1;
+	    else{
+	      cout << "t2lat: Error! Must specify the type of the corrector, Horizontal or vertical!" << endl;
+	      exit_(1);
+	    }
 	    GetSym__(&V);
 	  }
@@ -2743,9 +2747,4 @@
       WITH2->PN = k1;
       WITH2->PdTpar = dt;
-
-        if(Kplane == 0){
-	        cout << "t2lat: Error! Must specify the type of the corrector, Horizontal or vertical!" << endl;
-		exit_(1);
-	    }
       WITH2->PBpar[Kplane*Dip + HOMmax] = -1*QKick;  //assign the kick angle [rad]
  
@@ -3755,5 +3754,5 @@
   Reg("inv            ", invsym, &V);
   Reg("kick           ", corkicksym, &V); /* with "corrector", define the kick angle of the corrector ,  Jianfeng Zhang*/
-  Reg("kicker         ", kicksym, &V);
+ //Reg("kicker         ", kicksym, &V); /*overlap with the lattice element type: corrector*/
   Reg("ks             ", kssym, &V);
   Reg("lambda         ", lmdsym, &V);
@@ -4121,5 +4120,5 @@
 void GetEnergy(struct LOC_Lattice_Read *LINK)
 {
-  long k;
+  long k=0;
 
   k = CheckUDItable("energy         ", LINK);
@@ -4137,5 +4136,5 @@
 void GetRingType(struct LOC_Lattice_Read *LINK)
 {
-  long k;
+  long k=0;
 
   k = CheckUDItable("ringtype       ", LINK);
Index: /trunk/tracy/tracy/src/t2ring.cc
===================================================================
--- /trunk/tracy/tracy/src/t2ring.cc	(revision 31)
+++ /trunk/tracy/tracy/src/t2ring.cc	(revision 32)
@@ -196,5 +196,6 @@
 
    Purpose:
-     Computes Twiss parameters alpha and beta from the matrix Ascr
+     Assign the Twiss parameters alpha and beta from the matrix Ascr
+       to alpha & beta.
        
        M oneturn matrix    (A and M are symplectic)
@@ -218,5 +219,5 @@
 
    Return:
-       none
+       alpha, beta.
 
    Global variables:
@@ -233,5 +234,5 @@
 void getprm(Matrix &Ascr, Vector2 &alpha, Vector2 &beta)
 {
-  int  i, j;
+  int  i=0, j=0;
 
   for (i = 1; i <= 2; i++) {
@@ -253,5 +254,5 @@
        i0     first element
        i1     last element
-       ring   true if a ring
+       ring   true if a ring, false is a transfer line
        chroma true if compute chromaticities
        dP     energy offset
@@ -278,21 +279,21 @@
 		  bool ring, double dP)
 {
-  long int  i;
-  int       j, k;
+  long int  i=0L;
+  int       j=0, k=0;
   Vector2   nu1, dnu;
-  Vector    xref;
-  Matrix    Ascr0, Ascr1;
+  Vector    xref;                   /*6*1 vector*/
+  Matrix    Ascr0, Ascr1;           /*6*6 matrix*/
   CellType  *cellp;
 
   if (dP != globval.dPparticle) Cell_SetdP(dP);
 
-  /* Init */  
+  /* Initize the phase */  
   for (j = 0; j <= 1; j++)
-    nu1[j] = 0.0;
-
-  /* get alpha beta for i0 */  
+    nu1[j] = 0.0;  /*phase advance*/
+
+  /* get alpha & beta for i0 */  
   cellp = &Cell[i0];
-  getprm(Ascr, cellp->Alpha, cellp->Beta);
-  memcpy(cellp->Nu, nu1, sizeof(Vector2));
+  getprm(Ascr, cellp->Alpha, cellp->Beta);  /*initialize the alpha & beta functions */
+  memcpy(cellp->Nu, nu1, sizeof(Vector2));  /*initialize the phase advance*/
   CopyMat(n+1, Ascr, Ascr0); CopyVec(n+2L, globval.CODvect, xref);
 
@@ -301,9 +302,11 @@
     /* Ascr1=Elem_M*Ascr0 */
     /* xref =Elem(xref)   */
-    Elem_Pass_M(i, xref, Ascr1); 
+    Elem_Pass_M(i, xref, Ascr1);   /* transport orbit & optic matrix */
 
     cellp = &Cell[i];
     /* get alpha and beta for element i */
     getprm(Ascr1, cellp->Alpha, cellp->Beta);
+    /*save the orbit at the end of the lattice elment*/
+    CopyVec(ss_dim, xref,cellp->CODvect);
 
     for (j = 0; j <= 1; j++) {
@@ -861,7 +864,7 @@
                 Vector2 &etap, Vector &codvect)
 {
-  long i, j, lastpos;
-  double sb;
-  Matrix Ascr;
+  long i=0L, j=0L, lastpos=0L;
+  double sb=0.0;
+  Matrix Ascr; /* 6*6 transfer matrix*/
 
   UnitMat(6L, Ascr);
